<?php

$sql_fpath = $base_dir.'database';

$sql_user='root';
$sql_password='';
$sql_database='mail';
$sql_host='localhost';

class MysqlKernel {
	var $err, $h;
	
	function __construct() {
		global $sql_host, $sql_user, $sql_password, $sql_database;
		
		$this->err = '';
		$this->h = @mysql_connect($sql_host, $sql_user, $sql_password);
		if($this->h===FALSE) {
			error_add('MysqlKernel::MysqlKernel()', $this->err);
			return;
		}
		
		if(!@mysql_select_db($sql_database, $this->h))
		{
			$this->err=mysql_error($this->h);
			mysql_close($this->h);
			$this->h=0;
			error_add('sql_connect',$this->err);
			return;
		}
	}
	
	function symSome($str,$symbols) {
		return ereg('^['.$symbols.']+$',$str);
	}
	
	function wrapList($data) {
		$sqlst = '';
		foreach($data as $key => $value) {
			if($this->symSome($key,'A-Za-z0-9_')) {
				$sqlst .= ", `".$key."`='".mysql_real_escape_string($value, $this->h)."'";
			}
		}
		return substr($sqlst,1);
	}
	
	function wrapAndList($data) {
		$arr = array();
		foreach($data as $key => $value) {
			if($this->symSome($key,'A-Za-z0-9_')) {
				$arr[] = "`".$key."`='".mysql_real_escape_string($value, $this->h);
			}
		}
		return implode(' AND ',$arr);
	}
	
	function query($q) {
		if(!$this->h) return FALSE;
		$r = @mysql_query($q,$this->h);
		$this->err = mysql_error($this->h);
		return $r;
	}
	
	function insertInto($table, $data) {
		$this->query('INSERT INTO '.$table.' SET '.$this->wrapList($data));
		if($this->err) return false;
		return true;
	}
	
	function getLatestId() {
		if(!$this->h) return -1;
		return mysql_insert_id($this->h);
	}
	
	function loadAll($q) {
		$res = $this->query($q);
		if($res===FALSE) return NULL;
		
		$res2 = array();
		while($row = mysql_fetch_assoc($res)) $res2[] = $row;
		mysql_free_result($res);
		
    	return $res2;
	}
	
	function loadSingle($q) {
		$res = $this->loadAll($q);
		if($res===NULL) return NULL;
		return $res[0];
	}
	
	function getConcepts($table, $params, $start = 0, $limit=1000000) {
		$start = (int)$start;
		$limit = (int)$limit;
		$list = $this->wrapAndList($params);
		return $this->loadAll('SELECT * FROM `$table` WHERE $list LIMIT $start,$limit');
	}
	
	function close() {
		if($this->h) @mysql_close($this->h);
		$this->h=0;
		$this->err='';
	}
}


?>